# -*- coding: utf-8 -*-
"""
Created on Sun May 24 21:25:08 2020

@author: USER
"""

# -*- coding: utf-8 -*-
"""
Created on Sun Apr 19 18:42:04 2020

@author: USER
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx


N=500
H=np.zeros([N],float)
for i in range(0,N):
    H[i]=10000.
#A=np.loadtxt('small_world_network_300_5_0.3.txt',float)
A=np.loadtxt('scale_free_network_500_14.txt',float)    
G=nx.Graph(A)
degree = A.sum(axis=1)
row_sums= A.sum(axis=1)
A1=A/row_sums[:,np.newaxis]

bet_c=nx.betweenness_centrality(G)
clu_c=nx.clustering(G)
eigen=[]
clo=[]
bet=[]
clu=[]
for i in range(0,N):
    bet.append(bet_c[i])
    clu.append(clu_c[i])
    
a=[]
for i in range(0,N):
    a.append(1./N)

a3=[x/np.sum(degree) for x in degree]
a6=[x/np.sum(bet) for x in bet]
a7=[x/np.sum(clu) for x in clu]


#B=np.loadtxt('distributed_beta_300.txt',float)
B=[]
for i in range(0,N):
    B.append(0.05)
v=np.zeros([5,N],float)
v[1,:]=a[:]
v[2,:]=a3[:]
v[3,:]=a6[:]
v[4,:]=a7[:]

       
#f1 = lambda x:c0+c1*x
def f(y,t):
    dy = np.empty(5*N+1,float)
    s = y[0:5*N:5]
    e = y[1:5*N:5]
    i_s = y[2:5*N:5]
    h = y[3:5*N:5]
    r = y[4:5*N:5]
    k = y[2500]
    S1 = np.dot(A1,s)
    S2 = np.dot(A1,e)
    S3 = np.dot(A1,i_s)
    S4 = np.dot(A1,r)
    #alpha = f1(k)
    for i in range(0,N):
        dy[5*i] = ((-B[i]*s[i]*i_s[i])/H[i] )+K*(S1[i]-s[i])
        dy[5*i+1] = ((B[i]*s[i]*i_s[i])/H[i]) -sigma*e[i] + K*(S2[i]- e[i])
        dy[5*i+2] = sigma*e[i] - (c0+(c1*R[i]*k))*i_s[i] + K*(S3[i] - i_s[i])
        dy[5*i+3] = (c0+(c1*R[i]*k))*i_s[i] - gamma*h[i] -delta*h[i]
        dy[5*i+4] = gamma*h[i] + K*(S4[i]-r[i])
    dy[2500] = xi*(np.sum(i_s)) - ki*k
    return dy
i_peak=[] 
peak_av=[]   
for k in range(0,1):
    print(k)
    R=v[k]
    sigma=0.1
    delta=0.0
    gamma=0.07
    c0=0.01
    c1=0.0001
    tf = 3000
    xi = 0.02
    ki = 0.1
    K=0.0001
    y0 = np.zeros(5*N+1,float)
    y0[0:5*N:5]=10000.
    y0[1:5*N+1:5]=0
    y0[2:5*N+2:5]=0
    y0[3:5*N+3:5]=0  
    y0[4:5*N+4:5]=0
    y0[0]=y0[20]=10000-20
    y0[1]=y0[21]=13
    y0[2]=y0[22]=7
    y0[3]=0.
    y0[4]=0.
    y0[2500]=10
    t1= np.linspace(0, tf, tf*100)
    [sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)


    i_1=[]
    for  i in range(0,N):
        i_1.append(np.max(sol1[:,5*i+2]))
  
    i_2=[]
    for i in range(0,tf*100):
        i_2.append(np.sum(sol1[i,2:5*N:5])/5000000.)
    i_peak.append(np.max(i_2))        
    l=['without-kit','identical','degree','betweenness','clustering']
    markers=["kx","bo","gP","ms","yX"]
    l2=['k--','b--','g--','m--','y--']
    ind1=(0,50000,100000,150000,200000,250000,300000)
    ind2=(0,0.05,.1,.15,.2)
    pl.figure(1)
    ma_on=[0,20000,40000,60000,80000,100000,120000,140000,160000,180000,200000,220000,240000,260000,280000]
    pl.plot(i_2,l2[k])
    pl.plot(ma_on,i_2[0:300000:20000],markers[k],label=l[k])
    pl.xlabel('$t$',fontsize=15)
    pl.ylabel(r'$cum-inf$',fontsize=15)
    pl.xticks(ind1,('0','500','1000','1500','2000','2500','3000'),fontsize=15)
    pl.yticks(ind2,('0','0.05','.1','.15','.2'),fontsize=15)
    pl.rcParams['axes.linewidth']=2
    pl.legend()
    pl.tight_layout()
#

#    
#    data_2=[0,10.5,100.5,1000.5]
#    L3= len(data_2)
#    tf=[]
#    tf_av=[]
#    for j in range(1,L3):
#        for i in range(0,300):
#            if data_2[j-1] < degree[i] < data_2[j]:
#                tf.append(i_1[i])
#        tf_av.append(np.mean(tf))
#        del tf[:]    
#    peak_av.append(tf_av)
#    d0=[]
#    for j in range(1,L3):
#        d0.append((data_2[j-1]+data_2[j])/2) 
##        
#    pl.figure(2)
#    ind5=(10,30,50,70,90)
#    ind6=(0,.25,.5,.75,1)
#    pl.plot(d0,tf_av,l2[k])
#    pl.plot(d0,tf_av,markers[k],label=l[k])
#    #pl.plot(ma_on,sol1[0:300000:20000,112],markers[k],label=l[k])
#    pl.xlabel('$d$',fontsize=15)
#    pl.ylabel(r'$peak-inf$',fontsize=15)
#    pl.xticks(ind5,('10','30','50','70','90'),fontsize=15)
#    pl.yticks(ind6,('0','.25','.5','.75','1'),fontsize=15)
#    pl.rcParams['axes.linewidth']=2
#    pl.legend()
#    pl.tight_layout()
#
#    np.savetxt('peak_inf_average_500_o10.txt',peak_av)
#    np.savetxt('average_degree_300.txt',d0)
#    np.savetxt('degree_range_300.txt',data_2)
