# -*- coding: utf-8 -*-
"""
Created on Thu May 07 20:13:05 2020

@author: USER
"""

# -*- coding: utf-8 -*-
"""
Created on Sun Apr 19 18:42:04 2020

@author: USER
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx
from collections import Counter


N=500
H=np.zeros([N],float)
for i in range(0,N):
    H[i]=10000.
A=np.loadtxt('scale_free_network_500_14.txt',float)
#A=np.loadtxt('small_world_network_500_14_0.3.txt',float)
#A=np.loadtxt('erdos_renyi_network_500_0.028.txt',float)
G=nx.Graph(A)
degree = A.sum(axis=1)
row_sums= A.sum(axis=1)
A1=A/row_sums[:,np.newaxis]
#N1=50
def createRandomSortedList(num,start = 0, end = 499):
    arr=[]
    tmp= random.randint(start,end)
    for x in range(num):
        while tmp in arr:
            tmp= random.randint(start,end)
        arr.append(tmp)
    arr.sort()
    return arr
#x1=np.random.randint(500,size=(N1,1))
#x1=createRandomSortedList(N1,0,499)
        
#u1=list(Counter(x1).items())
#v1 =list(Counter(x1).keys())
e_v_c=nx.eigenvector_centrality(G)
c_c=nx.closeness_centrality(G)
bet_c=nx.betweenness_centrality(G)
clu_c=nx.clustering(G)

bet=[]
clu=[]
for i in range(0,N):
    bet.append(bet_c[i])
    clu.append(clu_c[i])
deg_1=[]
bet_1=[]
clu_1=[]
for i in range(0,N):
    deg_1.append([degree[i],i])
    bet_1.append([bet_c[i],i])
    clu_1.append([clu_c[i],i])
deg_1.sort()
bet_1.sort()
clu_1.sort() 

B=np.loadtxt('distributed_beta_500.txt',float)

#B=[]
#for i in range(0,N):
#    B.append(0.05)
      
#f1 = lambda x:c0+c1*x
def f(y,t):
    dy = np.empty(5*N+1,float)
    s = y[0:5*N:5]
    e = y[1:5*N:5]
    i_s = y[2:5*N:5]
    h = y[3:5*N:5]
    r = y[4:5*N:5]
    k = y[2500]
    S1 = np.dot(A1,s)
    S2 = np.dot(A1,e)
    S3 = np.dot(A1,i_s)
    S4 = np.dot(A1,r)
    #alpha = f1(k)
    for i in range(0,N):
        dy[5*i] = ((-B[i]*s[i]*i_s[i])/H[i] )+K*(S1[i]-s[i])
        dy[5*i+1] = ((B[i]*s[i]*i_s[i])/H[i]) -sigma*e[i] + K*(S2[i]- e[i])
        dy[5*i+2] = sigma*e[i] - (c0+(c1*R[i]*k))*i_s[i] + K*(S3[i] - i_s[i])
        dy[5*i+3] = (c0+(c1*R[i]*k))*i_s[i] - gamma*h[i] -delta*h[i]
        dy[5*i+4] = gamma*h[i] + K*(S4[i]- r[i])
    dy[2500] = xi*(np.sum(i_s)) - ki*k
    return dy
f1=[0.0001,0.0005,0.001,0.005,0.01,0.05,0.1] 
f2=[25,50,100,200,300,400,500]   

inf_m=[]
for  q in range(0,len(f1)):
    print(q)
    K=f1[q]
    for j in range(0,len(f2)):
        print(j)
        N1=f2[j]
        x1=[]
        x1=createRandomSortedList(N1,0,499)
        x2=[]
        x3=[]
        x4=[]
        for i in range(0,N1):
            x2.append(deg_1[-N1:][i][1])
            x3.append(bet_1[-N1:][i][1])
            x4.append(clu_1[-N1:][i][1])
        a=np.zeros([N,1],float)
        for i in range(0,N1):
            a[x1[i]]=(1./N1)
        a03=np.zeros([N,1],float)
        for i in range(0,N1):
            a03[x2[i]]=degree[x2[i]]
        a07=np.zeros([N,1],float)
        for i in range(0,N1):
            a07[x4[i]]=clu[x4[i]]
        a06=np.zeros([N,1],float)
        for i in range(0,N1):
            a06[x3[i]]=bet[x3[i]]    
        a3=[x/np.sum(a03) for x in a03]    
        a6=[x/np.sum(a06) for x in a06]
        a7=[x/np.sum(a07) for x in a07]
        v=np.zeros([5,N],float)
        for i in range(0,N):
            v[1,i]=a[i][0]
            v[2,i]=a3[i][0]
            v[3,i]=a6[i][0]
            v[4,i]=a7[i][0]
        for k in range(0,5):
            print(k)
            R=v[k]
            sigma=0.1
            delta=0.0
            gamma=0.07
            c0=0.01
            c1=0.0001
            tf = 3000
            xi = 0.02
            ki = 0.1
            file_1=open('kit_phase_1.txt','a')
            y0 = np.zeros(5*N+1,float)
            y0[0:5*N:5]=10000.
            y0[1:5*N+1:5]=0
            y0[2:5*N+2:5]=0
            y0[3:5*N+3:5]=0  
            y0[4:5*N+4:5]=0
            y0[0]=y0[20]=10000-20
            y0[1]=y0[21]=13
            y0[2]=y0[22]=7
            y0[3]=0.
            y0[4]=0.
            y0[2500]=10
            t1= np.linspace(0, tf, tf*100)
            [sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)


            i_1=[]
            for  i in range(0,N):
                 i_1.append(np.max(sol1[:,5*i+2]))
  
            i_2=[]
            i_peak=[] 
            for i in range(0,tf*100):
                i_2.append(np.sum(sol1[i,2:5*N:5])/5000000.)
            i_peak.append(np.max(i_2))
            inf_m.append(i_peak)
            file_1.write("%s %s %s \n" % (str(f1[q]),str(f2[j]),str(inf_m[-1])))
            file_1.close()

            
#    l=['without-kit','identical','degree','betweenness','clustering']
#    markers=["ko","bx","gP","ms","yX"]
#    l2=['k--','b--','g--','m--','y--']
#    ind1=(0,100000,200000,300000)
#    ind2=(0,.1,.2,.3,.4)
#    pl.figure(1)
#    ma_on=[0,20000,40000,60000,80000,100000,120000,140000,160000,180000,200000,220000,240000,260000,280000]
#    pl.plot(i_2,l2[k])
#    pl.plot(ma_on,i_2[0:300000:20000],markers[k],label=l[k])
#    pl.xlabel('$t$',fontsize=25)
#    pl.ylabel(r'$cum-inf$',fontsize=25)
#    pl.xticks(ind1,('0','1000','2000','3000'),fontsize=20)
#    pl.yticks(ind2,('0','0.1','0.2','0.3','0.4'),fontsize=20)
#    pl.rcParams['axes.linewidth']=3
#    pl.legend()
#    pl.tight_layout()


    
      