# -*- coding: utf-8 -*-
"""
Created on Fri May 08 02:00:39 2020

@author: USER
"""

# -*- coding: utf-8 -*-
"""
Spyder Editor

This is a temporary script file.
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import ode
import pylab as pl
import random
import math
import scipy.io
import networkx as nx
from collections import Counter
N=500
A=np.loadtxt('scale_free_network_500_14.txt',float)
G=nx.Graph(A)
degree=np.sum(A,axis=0)
Beta=np.random.uniform(0.02,0.05,N)

e_v_c=nx.eigenvector_centrality(G)
c_c=nx.closeness_centrality(G)
bet_c=nx.betweenness_centrality(G)
clu_c=nx.clustering(G)
#g=nx.core_number(G)
p_r=nx.pagerank(G)
eigen=[]
clo=[]
bet=[]
clu=[]
page=[]
for i in range(0,N):
    eigen.append(e_v_c[i])
    clo.append(c_c[i])
    bet.append(bet_c[i])
    clu.append(clu_c[i]) 
    page.append(p_r[i])

N1=50

deg_1=[]
for i in range(0,N):
    deg_1.append([degree[i],i])

deg_1.sort()

x1=[]
for i in range(0,N1):
    x1.append(deg_1[-N1:][i][1])
degree_1=[]
bet_1=[]
clu_1=[]
clo_1=[]
eigen_1=[]
page_1=[]
for i in range(0,N1):
    degree_1.append(degree[x1[i]])
    bet_1.append(bet[x1[i]])
    clu_1.append(clu[x1[i]])
    clo_1.append(clo[x1[i]])
    eigen_1.append(eigen[x1[i]])
    page_1.append(page[x1[i]])    
    
pl.figure(1)
pl.plot(degree,'g.')
pl.plot(bet,'c.') 
pl.plot(clu,'y.')
pl.plot(clo,'b.')
#pl.plot(k_core,'k.')
pl.plot(page,'m.')
pl.figure(2)
pl.plot(degree,degree,'g.')
pl.plot(degree,bet,'c.')  
pl.plot(degree,clu,'y.')
pl.plot(degree,clo,'b.')
#pl.plot(degree,k_core,'k.')
pl.plot(degree,page,'m.')
pl.rcParams['axes.linewidth']=3


ind1=(10**0,10**1,10**2)
ind3=(10**-4,10**-3,10**-2,10**-1,10**0)
pl.figure(3,figsize=(6,6))
pl.scatter(degree,bet,s=40,color='none',edgecolors='pink',linewidths=2)
pl.scatter(degree_1,bet_1,s=80,color='none',edgecolors='red',linewidths=2)
#pl.plot(R0,I_n, color='darkblue',linewidth=5)    
pl.xlabel(r'$d$',fontsize=35)
pl.ylabel(r'$BC$',fontsize=35)
pl.xscale('log')
pl.yscale('log')
pl.xticks(ind1,fontsize=30)
pl.yticks(ind3,fontsize=30)
pl.rcParams['axes.linewidth']=3
pl.tick_params(which='both',direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2,color='k')
#pl.legend(loc='upper left',fontsize=24,frameon=False)
pl.tight_layout()




pl.figure(4,figsize=(6,6))
pl.scatter(degree,clu,s=40,color='none',edgecolors='khaki',linewidths=2)
pl.scatter(degree_1,clu_1,s=80,color='none',edgecolors='orange',linewidths=2)    
pl.xlabel(r'$d$',fontsize=35)
pl.ylabel(r'$CC $',fontsize=35)
pl.xscale('log')
pl.yscale('log')
pl.xticks(ind1,fontsize=30)
pl.yticks(ind3,fontsize=30)
pl.rcParams['axes.linewidth']=3
pl.tick_params(which='both',direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2,color='k')
#pl.legend(loc='upper left',fontsize=24,frameon=False)
pl.tight_layout()

ind4=(0.7,0.6,0.5,0.4,0.3)
pl.figure(5,figsize=(6,6))
pl.scatter(degree,clo,s=40,color='none',edgecolors='rosybrown',linewidths=2) 
pl.scatter(degree_1,clo_1,s=80,color='none',edgecolors='sienna',linewidths=2)  
pl.xlabel(r'$d$',fontsize=35)
pl.ylabel(r'$CLC $',fontsize=35)
pl.xscale('log')
pl.yscale('log')
pl.xticks(ind1,fontsize=30)
pl.yticks(ind4,fontsize=30)
pl.yticks(ind4,('7e-1','6e-1','5e-1','4e-1','3e-1'),fontsize=30)
pl.ticklabel_format(useMathText=True)
pl.rcParams['axes.linewidth']=3
pl.tick_params(which='both',direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2,color='k')
pl.tight_layout()

ind5=(10**-3,10**-2,10**-1)
pl.figure(6,figsize=(6,6))
pl.scatter(degree,page,s=40,color='none',edgecolors='lightblue',linewidths=2) 
pl.scatter(degree_1,page_1,s=80,color='none',edgecolors='darkcyan',linewidths=2) 
pl.xlabel(r'$d$',fontsize=35)
pl.ylabel(r'$PR$',fontsize=35)
pl.xscale('log')
pl.yscale('log')
pl.xticks(ind1,fontsize=30)
pl.yticks(ind5,fontsize=30)
pl.rcParams['axes.linewidth']=3
pl.tick_params(which='both',direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2,color='k')
pl.tight_layout()

ind6=(10**-2,10**-1,10**0)
pl.figure(7,figsize=(6,6))
pl.scatter(degree,eigen,s=40,color='none',edgecolors='violet',linewidths=2)
pl.scatter(degree_1,eigen_1,s=80,color='none',edgecolors='magenta',linewidths=2)    
pl.xlabel(r'$d$',fontsize=35)
pl.ylabel(r'$EC $',fontsize=35)
pl.xscale('log')
pl.yscale('log')
pl.xticks(ind1,fontsize=30)
pl.yticks(ind6,fontsize=30)
pl.rcParams['axes.linewidth']=3
pl.tick_params(which='both',direction= 'in', length=10,width=5)
pl.tick_params(which='minor',direction= 'in', length=5,width=2,color='k')
pl.tight_layout()