# -*- coding: utf-8 -*-
"""
Created on Sun Aug 16 14:56:26 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx

m_1=np.loadtxt('hist_zfos_0.05_10_0.03.txt',float)
m_2=np.loadtxt('hist_zfos_0.05_20_0.03.txt',float)
m_3=np.loadtxt('hist_zfos_0.05_100_0.03.txt',float)
n_1=np.loadtxt('hist_zfos_0.01_10_0.03.txt',float)
n_2=np.loadtxt('hist_zfos_0.01_20_0.03.txt',float)
n_3=np.loadtxt('hist_zfos_0.01_100_0.03.txt',float)


l=np.arange(0.5,8.5,0.5)
P=l.reshape(4,4)
p=P.transpose()
p[0:4,1]=1+p[0:4,1]
p[0:4,2]=2+p[0:4,2]
p[0:4,3]=3+p[0:4,3]

      
v=['SI','SD','SB','SC']        
ind = (1.25,4.25,7.25) 
ind2=(0,.25,.5,.75,1)   

          
pl.figure(1,figsize=(6,6))
pl.hist(p[0,0],2,weights=m_1[4],color='orange',label=v[3],edgecolor='k',linewidth=2)
pl.hist(p[1,0],2,weights=m_1[1],color='b',label=v[0],edgecolor='k',linewidth=2)
pl.hist(p[2,0],2,weights=m_1[3],color='r',label=v[2])
pl.hist(p[3,0],2,weights=m_1[2],color='g',label=v[1])
pl.hist(p[0,1],2,weights=m_2[4],color='orange')
pl.hist(p[1,1],2,weights=m_2[1],color='b')
pl.hist(p[2,1],2,weights=m_2[3],color='r')
pl.hist(p[3,1],2,weights=m_2[2],color='g')
pl.hist(p[0,2],2,weights=m_3[4],color='orange')
pl.hist(p[1,2],2,weights=m_3[1],color='b')
pl.hist(p[2,2],2,weights=m_3[3],color='r')
pl.hist(p[3,2],2,weights=m_3[2],color='g')
#x=np.arange(len(y))
#pl.barh(x,y)
pl.xlabel('$N_d$(%)',fontsize=35)
pl.ylabel(r'$Z_{FOS}$(%)',fontsize=35)
pl.xticks(ind,('10','20','100'),fontsize=25)
pl.yticks(ind2,('0','25','50','75','100'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.legend(frameon=False,fontsize=18)  
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()     

pl.figure(2,figsize=(6,6))
pl.hist(p[0,0],2,weights=n_1[4],color='orange',label=v[3])
pl.hist(p[1,0],2,weights=n_1[1],color='b',label=v[0])
pl.hist(p[2,0],2,weights=n_1[3],color='r',label=v[2])
pl.hist(p[3,0],2,weights=n_1[2],color='g',label=v[1])
pl.hist(p[0,1],2,weights=n_2[4],color='orange')
pl.hist(p[1,1],2,weights=n_2[1],color='b')
pl.hist(p[2,1],2,weights=n_2[3],color='r')
pl.hist(p[3,1],2,weights=n_2[2],color='g')
pl.hist(p[0,2],2,weights=n_3[4],color='orange')
pl.hist(p[1,2],2,weights=n_3[1],color='b')
pl.hist(p[2,2],2,weights=n_3[3],color='r')
pl.hist(p[3,2],2,weights=n_3[2],color='g')
#x=np.arange(len(y))
#pl.barh(x,y)
pl.xlabel('$N_d$(%)',fontsize=35)
pl.ylabel(r'$Z_{FOS}$(%)',fontsize=35)
pl.xticks(ind,('10','20','100'),fontsize=25)
pl.yticks(ind2,('0','0.25','0.5','0.75','1'),fontsize=25)
pl.rcParams['axes.linewidth']=3
#pl.legend(frameon=False,fontsize=20)  
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout() 
    