# -*- coding: utf-8 -*-
"""
Created on Sat Aug 15 15:56:24 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import scipy.io
import math
import networkx as nx
from collections import Counter

os_wok=np.loadtxt('zfos_wok_0.05.txt',float)
os_si_10=np.loadtxt('zfos_SI_10.txt',float)
os_sd_10=np.loadtxt('zfos_SD_10.txt',float)
os_sb_10=np.loadtxt('zfos_SB_10.txt',float)
os_sc_10=np.loadtxt('zfos_SC_10.txt',float)
os_si_20=np.loadtxt('zfos_SI_20.txt',float)
os_sd_20=np.loadtxt('zfos_SD_20.txt',float)
os_sb_20=np.loadtxt('zfos_SB_20.txt',float)
os_sc_20=np.loadtxt('zfos_SC_20.txt',float)
os_si_100=np.loadtxt('zfos_SI_100.txt',float)
os_sd_100=np.loadtxt('zfos_SD_100.txt',float)
os_sb_100=np.loadtxt('zfos_SB_100.txt',float)
os_sc_100=np.loadtxt('zfos_SC_100.txt',float)
b=np.loadtxt('zfos_net_beta.txt',float) 
l=['SW','SI','SD','SB','SC']
markers=["ko","b*","gs"]
l2=['k','b','g','r','orange']
ind3=(0,0.02,0.04,0.06)
ind4=(0,0.2,0.4,0.6,0.8,1,1.02) 
pl.figure(1,figsize=(6,6))
pl.plot(b,os_wok,l2[0],linewidth=5,label=l[0])
pl.plot(b,os_si_10,l2[1],linewidth=5,label=l[1])
pl.plot(b,os_sd_10,l2[2],linewidth=5,label=l[2])
pl.plot(b,os_sb_10,l2[3],linewidth=5,label=l[3])
pl.plot(b,os_sc_10,l2[4],linewidth=5,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$Z_{FOS}$',fontsize=35)
pl.yticks(ind4,('0','0.2','0.4','0.6','0.8','1',''),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='lower right',fontsize=20)
pl.tight_layout()  

pl.figure(2,figsize=(6,6))
pl.plot(b,os_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,os_si_10,l2[1],linewidth=4,label=l[1])
pl.plot(b,os_sd_10,l2[2],linewidth=5,label=l[2])
pl.plot(b,os_sb_10,l2[3],linewidth=4,label=l[3])
pl.plot(b,os_sc_10,l2[4],linewidth=4,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{Z_{\rm FOS}}$',fontsize=35)
pl.yticks(ind4,('0','0.2','0.4','0.6','0.8','1',''),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='lower right',frameon=False,fontsize=24)
pl.tight_layout()

pl.figure(3,figsize=(6,6))
pl.plot(b,os_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,os_si_20,l2[1],linewidth=4,label=l[1])
pl.plot(b,os_sd_20,l2[2],linewidth=5,label=l[2])
pl.plot(b,os_sb_20,l2[3],linewidth=4,label=l[3])
pl.plot(b,os_sc_20,l2[4],linewidth=4,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{Z_{\rm FOS}}$',fontsize=35)
pl.yticks(ind4,('0','0.2','0.4','0.6','0.8','1',''),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='lower right',frameon=False,fontsize=24)
pl.tight_layout()  

pl.figure(4,figsize=(6,6))
pl.plot(b,os_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,os_si_100,l2[1],linewidth=4,label=l[1])
pl.plot(b,os_sd_100,l2[2],linewidth=5,label=l[2])
pl.plot(b,os_sb_100,l2[3],linewidth=4,label=l[3])
pl.plot(b,os_sc_100,l2[4],linewidth=4,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{Z_{\rm FOS}}$',fontsize=35)
pl.yticks(ind4,('0','0.2','0.4','0.6','0.8','1',''),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='lower right',frameon=False,fontsize=24)
pl.tight_layout()  