# -*- coding: utf-8 -*-
"""
Created on Sat Aug 15 15:56:24 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import scipy.io
import math
import networkx as nx
from collections import Counter

I_wok=np.loadtxt('I_wok_0.05.txt',float)
I_si_10=np.loadtxt('I_SI_10_0.03.txt',float)
I_sd_10=np.loadtxt('I_SD_10.txt',float)
I_sb_10=np.loadtxt('I_SB_10.txt',float)
I_sc_10=np.loadtxt('I_SC_10.txt',float)
I_si_20=np.loadtxt('I_SI_20.txt',float)
I_sd_20=np.loadtxt('I_SD_20.txt',float)
I_sb_20=np.loadtxt('I_SB_20.txt',float)
I_sc_20=np.loadtxt('I_SC_20.txt',float)
I_si_100=np.loadtxt('I_SI_100.txt',float)
I_sd_100=np.loadtxt('I_SD_100.txt',float)
I_sb_100=np.loadtxt('I_SB_100.txt',float)
I_sc_100=np.loadtxt('I_SC_100.txt',float)
b=np.loadtxt('zfos_net_beta.txt',float) 
l=['SW','SI','SD','SB','SC']
markers=["ko","b*","gs"]
l2=['k','b','g','r','orange']
ind3=(0,0.02,0.04,0.06)
ind4=(0,0.1,0.2,0.3,0.4,0.5) 
pl.figure(1,figsize=(6,6))
pl.plot(b,I_wok,l2[0],linewidth=5,label=l[0])
pl.plot(b,I_si_10,l2[1],linewidth=5,label=l[1])
pl.plot(b,I_sd_10,l2[2],linewidth=5,label=l[2])
pl.plot(b,I_sb_10,l2[3],linewidth=5,label=l[3])
pl.plot(b,I_sc_10,l2[4],linewidth=5,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{I_{\rm max}}$',fontsize=35)
pl.yticks(ind4,('0','0.1','0.2','0.3','0.4','0.5'),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='lower right',fontsize=20)
pl.tight_layout()  

pl.figure(2,figsize=(6,6))
pl.plot(b,I_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,I_si_10,l2[1],linewidth=4,label=l[1])
pl.plot(b,I_sd_10,l2[2],linewidth=5,label=l[2])
pl.plot(b,I_sb_10,l2[3],linewidth=4,label=l[3])
pl.plot(b,I_sc_10,l2[4],linewidth=4,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{I_{\rm max}}$',fontsize=35)
pl.yticks(ind4,('0','0.1','0.2','0.3','0.4','0.5'),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='upper left',frameon=False,fontsize=24)
pl.tight_layout()

pl.figure(3,figsize=(6,6))
pl.plot(b,I_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,I_si_20,l2[1],linewidth=4,label=l[1])
pl.plot(b,I_sd_20,l2[2],linewidth=5,label=l[2])
pl.plot(b,I_sb_20,l2[3],linewidth=4,label=l[3])
pl.plot(b,I_sc_20,l2[4],linewidth=4,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{I_{\rm max}}$',fontsize=35)
pl.yticks(ind4,('0','0.1','0.2','0.3','0.4','0.5'),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='upper left',frameon=False,fontsize=24)
pl.tight_layout()  

pl.figure(4,figsize=(6,6))
pl.plot(b,I_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,I_si_100,l2[1],linewidth=4,label=l[1])
pl.plot(b,I_sd_100,l2[2],linewidth=5,label=l[2])
pl.plot(b,I_sb_100,l2[3],linewidth=4,label=l[3])
pl.plot(b,I_sc_100,l2[4],linewidth=4,label=l[4])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{I_{\rm max}}$',fontsize=35)
pl.yticks(ind4,('0','0.1','0.2','0.3','0.4','0.5'),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='upper left',frameon=False,fontsize=24)
pl.tight_layout()  