# -*- coding: utf-8 -*-
"""
Created on Fri Aug 14 16:23:06 2020

@author: subrata
"""


import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx

m_1=np.loadtxt('hist_0.05_10.txt',float)
m_2=np.loadtxt('hist_0.05_20.txt',float)
m_3=np.loadtxt('hist_0.05_100.txt',float)
n_1=np.loadtxt('hist_0.01_10.txt',float)
n_2=np.loadtxt('hist_0.01_20.txt',float)
n_3=np.loadtxt('hist_0.01_100.txt',float)
m1=[1-(x/m_1[0]) for x in m_1]
m2=[1-(x/m_2[0]) for x in m_2]
m3=[1-(x/m_3[0]) for x in m_3]
n1=[1-(x/n_1[0]) for x in n_1]
n2=[1-(x/n_2[0]) for x in n_2]
n3=[1-(x/n_3[0]) for x in n_3]

l=np.arange(0,16,1)
P=l.reshape(4,4)
p=P.transpose()
p[0:4,1]=1+p[0:4,1]
p[0:4,2]=2+p[0:4,2]
p[0:4,3]=3+p[0:4,3]

      
v=['SI','SD','SB','SC']        
ind = (1.5,6.5,11.5) 
ind2=(0,.25,.5,.75,1)   

          
pl.figure(1,figsize=(10,10))
pl.hist(p[0,0],1,weights=m1[4],color='orange',label=v[3],edgecolor='k',linewidth=2)
pl.hist(p[1,0],1,weights=m1[1],color='b',label=v[0],edgecolor='k',linewidth=2)
pl.hist(p[2,0],1,weights=m1[3],color='r',label=v[2],edgecolor='k',linewidth=2)
pl.hist(p[3,0],1,weights=m1[2],color='g',label=v[1],edgecolor='k',linewidth=2)
pl.hist(p[0,1],1,weights=m2[4],color='orange',edgecolor='k',linewidth=2)
pl.hist(p[1,1],1,weights=m2[1],color='b',edgecolor='k',linewidth=2)
pl.hist(p[2,1],1,weights=m2[3],color='r',edgecolor='k',linewidth=2)
pl.hist(p[3,1],1,weights=m2[2],color='g',edgecolor='k',linewidth=2)
pl.hist(p[0,2],1,weights=m3[4],color='orange',edgecolor='k',linewidth=2)
pl.hist(p[1,2],1,weights=m3[1],color='b',edgecolor='k',linewidth=2)
pl.hist(p[2,2],1,weights=m3[3],color='r',edgecolor='k',linewidth=2)
pl.hist(p[3,2],1,weights=m3[2],color='g',edgecolor='k',linewidth=2)
#x=np.arange(len(y))
#pl.barh(x,y)
pl.xlabel('$N_d$(%)',fontsize=60)
pl.ylabel(r'$RR}$(%)',fontsize=60)
pl.xticks(ind,('10','20','100'),fontsize=50)
pl.yticks(ind2,('0','25','50','75','100'),fontsize=50)
pl.rcParams['axes.linewidth']=3
pl.legend(frameon=False,fontsize=31)  
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout() 

pl.figure(2,figsize=(10,10))
pl.hist(p[0,0],1,weights=n1[4],color='orange',label=v[3],edgecolor='k',linewidth=2)
pl.hist(p[1,0],1,weights=n1[1],color='b',label=v[0],edgecolor='k',linewidth=2)
pl.hist(p[2,0],1,weights=n1[3],color='r',label=v[2],edgecolor='k',linewidth=2)
pl.hist(p[3,0],1,weights=n1[2],color='g',label=v[1],edgecolor='k',linewidth=2)
pl.hist(p[0,1],1,weights=n2[4],color='orange',edgecolor='k',linewidth=2)
pl.hist(p[1,1],1,weights=n2[1],color='b',edgecolor='k',linewidth=2)
pl.hist(p[2,1],1,weights=n2[3],color='r',edgecolor='k',linewidth=2)
pl.hist(p[3,1],1,weights=n2[2],color='g',edgecolor='k',linewidth=2)
pl.hist(p[0,2],1,weights=n3[4],color='orange',edgecolor='k',linewidth=2)
pl.hist(p[1,2],1,weights=n3[1],color='b',edgecolor='k',linewidth=2)
pl.hist(p[2,2],1,weights=n3[3],color='r',edgecolor='k',linewidth=2)
pl.hist(p[3,2],1,weights=n3[2],color='g',edgecolor='k',linewidth=2)
#x=np.arange(len(y))
#pl.barh(x,y)
pl.xlabel('$N_d$(%)',fontsize=45)
pl.ylabel(r'$RR$(%)',fontsize=45)
pl.xticks(ind,('10','20','100'),fontsize=30)
pl.yticks(ind2,('0','25','50','75','100'),fontsize=30)
pl.rcParams['axes.linewidth']=3
pl.legend(frameon=False,fontsize=31)  
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout()      