# -*- coding: utf-8 -*-
"""
Created on Tue Sep  8 22:25:03 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx

m_1=np.loadtxt('hist_0.05_10_all.txt',float)

m1=[1-(x/m_1[0]) for x in m_1]

l=np.arange(0,12,1.5)
P=l.reshape(8,1)
p=P.transpose()


      
v=['SI','SD','SB','SC','SCLC','SEC','SPR']        
ind = (0,1.5,3,4.5,6,7.5,9)
ind2=(0,.25,.5,.75,1)   

          
pl.figure(1,figsize=(6,6))
pl.hist(p[0,0],1,weights=m1[1],color='blue',edgecolor='k',linewidth=2)
pl.hist(p[0,1],1,weights=m1[2],color='darkgreen',edgecolor='k',linewidth=2)
pl.hist(p[0,2],1,weights=m1[3],color='r',edgecolor='k',linewidth=2)
pl.hist(p[0,3],1,weights=m1[4],color='darkorange',edgecolor='k',linewidth=2)
pl.hist(p[0,4],1,weights=m1[5],color='sienna',edgecolor='k',linewidth=2)
pl.hist(p[0,5],1,weights=m1[6],color='magenta',edgecolor='k',linewidth=2)
pl.hist(p[0,6],1,weights=m1[7],color='darkcyan',edgecolor='k',linewidth=2)


#x=np.arange(len(y))
#pl.barh(x,y)
#pl.xlabel('$N_d$(%)',fontsize=60)
pl.ylabel(r'$RR}$(%)',fontsize=35)
pl.xticks(ind,('SI','SD','SB','SC','SCL','SE','SP'),fontsize=25)
pl.yticks(ind2,('0','25','50','75','100'),fontsize=25)
pl.rcParams['axes.linewidth']=3
#pl.legend(frameon=False,fontsize=31)  
pl.tick_params(direction= 'out', length=7,width=3)
pl.tight_layout() 