# -*- coding: utf-8 -*-
"""
Created on Fri Aug 21 15:30:49 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx
from scipy import optimize
from scipy.misc import derivative

N=500
A=np.loadtxt('scale_free_network_500_14.txt',float)
G=nx.Graph(A)
degree=np.sum(A,axis=0)
row_sums= A.sum(axis=1)
A1=A/row_sums[:,np.newaxis]
b=0.03
sigma=0.1
ep=0.05
a0=0.01
O=np.zeros([N,N],float)
I=-sigma*np.eye(N,N)
F=np.zeros([2*N,2*N],float)
for i in range(0,N):
    F[i,i+500]=b
V=np.zeros([2*N,2*N],float) 
V1=np.zeros([N,N],float)
for i in range(0,N):
    for j in range(0,N):
        V1[i,j]=-(ep*A1[i,j])
        V1[i,i]=sigma+ep

V2=np.zeros([N,N],float)
for i in range(0,N):
    for j in range(0,N):
        V2[i,j]=(ep*A1[i,j]) 
        V2[i,i]=0

       
for i in range(0,N):
    for j in range(0,N):
        V[i,j]=-ep*(A1[i,j])
        V[i,i]=sigma+ep
                
for i in range(0,N):
    V[i+500,i]= - sigma
    
for i in range(N,2*N):
    for j in range(N,2*N):
        V[i,j]= -ep*(A1[i-N,j-N] )
        V[i,i]= a0+ep
B=np.dot(F,np.linalg.inv(V))        
u,v=np.linalg.eig(B)
r1=[x.real for x in u]
r2=[x.imag for x in u]
p,q=np.linalg.eig(V2)
s1=[x.real for x in p]
s2=[x.imag for x in p]

pl.figure(1)
pl.hist(r1,100)
pl.figure(2)
pl.scatter(r1,r2, color='red') 
pl.figure(3)
pl.hist(s1,100)
pl.figure(4)
pl.scatter(s1,s2, color='red') 