# -*- coding: utf-8 -*-
"""
Created on Fri Aug 28 12:52:54 2020

@author: subrata
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import scipy.io
import math
import networkx as nx
from collections import Counter

os_wok=np.loadtxt('zfos_wok_cal(l+b).txt',float)
os_sd_10=np.loadtxt('zfos_SD_cal(l+b)_10.txt',float)
os_sd_20=np.loadtxt('zfos_SD_cal(l+b)_20.txt',float)
os_sd_100=np.loadtxt('zfos_SD_cal(l+b)_100.txt',float)
b=np.loadtxt('cal_beta.txt',float)
I_wok=np.loadtxt('Imax_wok_cal(l+b).txt',float)
I_sd_10=np.loadtxt('Imax_SD_cal(l+b)_10.txt',float) 
I_sd_20=np.loadtxt('Imax_SD_cal(l+b)_20.txt',float)
I_sd_100=np.loadtxt('Imax_SD_cal(l+b)_100.txt',float)
#I_si_10=np.loadtxt('Imax_SI_10_cal.txt',float)
l=['SW','10%','20%','100%']
l2=['k','darkgreen','lime','mediumaquamarine','b']
ind3=(0,0.02,0.04,0.06)
ind5=(0,0.02,0.04,0.06,0.08)
ind4=(0,0.2,0.4,0.6,0.8,1,1.02) 
pl.figure(1,figsize=(6,6))
pl.plot(b,os_wok,l2[0],linewidth=5,label=l[0])
pl.plot(b,os_sd_10,l2[1],linewidth=5,label=l[1])
pl.plot(b,os_sd_20,l2[2],linewidth=5,label=l[2])
pl.plot(b,os_sd_100,l2[3],linewidth=5,label=l[3])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$Z_{FOS}$',fontsize=35)
pl.yticks(ind4,('0','0.2','0.4','0.6','0.8','1',''),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='lower right',fontsize=20)
pl.tight_layout()  

pl.figure(2,figsize=(6,6))
pl.plot(b,os_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,os_sd_10,l2[1],linewidth=4,label=l[1])
pl.plot(b,os_sd_20,l2[2],linewidth=4,label=l[2])
pl.plot(b,os_sd_100,l2[3],linewidth=4,label=l[3])
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{Z}_{\rm FOS}$',fontsize=35)
pl.yticks(ind4,('0','0.2','0.4','0.6','0.8','1',''),fontsize=25)
pl.xticks(ind5,('0','0.02','0.04','0.06','0.08'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='lower right',frameon=False,fontsize=24)
pl.tight_layout()

ind3=(0,0.02,0.04,0.06)
ind4=(0,0.1,0.2,0.3,0.4,0.5) 
pl.figure(3,figsize=(6,6))
pl.plot(b,I_wok,l2[0],linewidth=4,label=l[0])
pl.plot(b,I_sd_10,l2[1],linewidth=4,label=l[1])
pl.plot(b,I_sd_20,l2[2],linewidth=4,label=l[2])
pl.plot(b,I_sd_100,l2[3],linewidth=4,label=l[3])
#pl.plot(b,I_si_10,l2[4],linewidth=4)
pl.xlabel(r'$\beta$',fontsize=35)
pl.ylabel(r'$\mathcal{I}_{\rm max}$',fontsize=35)
pl.yticks(ind4,('0','0.1','0.2','0.3','0.4','0.5'),fontsize=25)
pl.xticks(ind3,('0','0.02','0.04','0.06'),fontsize=25)
pl.rcParams['axes.linewidth']=3
pl.tick_params(direction= 'in', length=7,width=3)
#pl.axis('equal')
pl.legend(loc='upper left',fontsize=23,frameon=False)
pl.tight_layout()  