# -*- coding: utf-8 -*-
"""
Created on Mon Jul 20 06:55:52 2020

@author: subrata
"""



import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx
from collections import Counter


N=500
H=np.zeros([N],float)
for i in range(0,N):
    H[i]=10000.
A=np.loadtxt('scale_free_network_500_14.txt',float)
#A=np.loadtxt('one_hub_106_links.txt',float)    
G=nx.Graph(A)
degree = A.sum(axis=1)
row_sums= A.sum(axis=1)
A1=A/row_sums[:,np.newaxis]
B=[]
for i in range(0,N):
    B.append(0.05)
deg_1=[]
for i in range(0,N):
    deg_1.append([degree[i],i])
deg_1.sort() 

def f(y,t):
    dy = np.empty(5*N+1,float)
    s = y[0:5*N:5]
    e = y[1:5*N:5]
    i_s = y[2:5*N:5]
    h = y[3:5*N:5]
    r = y[4:5*N:5]
    k = y[2500]
    S1 = np.dot(A1,s)
    S2 = np.dot(A1,e)
    S3 = np.dot(A1,i_s)
    S4 = np.dot(A1,r)
    #alpha = f1(k)
    for i in range(0,N):
        dy[5*i] = ((-B[i]*s[i]*i_s[i])/H[i] )+K*(S1[i]-s[i])
        dy[5*i+1] = ((B[i]*s[i]*i_s[i])/H[i]) -sigma*e[i] + K*(S2[i]- e[i])
        dy[5*i+2] = sigma*e[i] - (c0+(c1*R[i]*k))*i_s[i] + K*(S3[i] - i_s[i])
        dy[5*i+3] = (c0+(c1*R[i]*k))*i_s[i] - gamma*h[i] -delta*h[i]
        dy[5*i+4] = gamma*h[i] + K*(S4[i] - r[i])
    dy[2500] = xi*(np.sum(i_s)) - ki*k
    return dy
i_peak=[]    
u1=np.arange(0,150,50)
#u1=np.arange(0,525,25)
for i in range(2,len(u1)):
    N1=u1[i]
    print(N1)
    x2=[]
    for i in range(0,N1):
        x2.append(deg_1[-N1:][i][1])
#    x2=[]
#    for i in range(0,N1):
#        x2.append(deg_1[:][i][1])     
    a03=np.zeros([N,1],float)
    for i in range(0,N1):
        a03[x2[i]]=degree[x2[i]]   
    a3=[x/np.sum(a03) for x in a03]
    a=np.where(np.isnan(a3),0,a3)
    v=np.zeros([1,N],float)
    for i in range(0,N):
        v[0,i]=a[i][0]
    R=v[0]
    sigma=0.1
    delta=0.0
    gamma=0.07
    c0=0.01
    c1=0.0001
    tf = 1500
    xi = 0.02
    ki = 0.1
    K=0.05
    y0 = np.zeros(5*N+1,float)
    y0[0:5*N:5]=10000.
    y0[1:5*N+1:5]=0
    y0[2:5*N+2:5]=0
    y0[3:5*N+3:5]=0  
    y0[4:5*N+4:5]=0
    y0[20]=10000-20
    y0[21]=13
    y0[22]=7
    y0[3]=0.
    y0[4]=0.
    y0[2500]=10
    t1= np.linspace(0, tf, tf*100)
    [sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)


    i_1=[]
    for  i in range(0,N):
        i_1.append(sol1[-1,5*i+4])
  
    i_2=[]
    for i in range(0,tf*100):
        i_2.append(np.sum(sol1[i,2:5*N:5])/5000000.)
    i_peak.append(np.max(i_2))
                   
#np.savetxt('hub_check_data_per_0.05.txt',i_peak)
    pl.figure(1)
    pl.plot(degree,i_1,'r.')
    #pl.yscale('log')    
#      