# -*- coding: utf-8 -*-
"""
Created on Sun Apr 19 18:42:04 2020

@author: USER
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx

N=500
H=np.zeros([N],float)
for i in range(0,N):
    H[i]=10000.

A=np.loadtxt('scale_free_network_500_14.txt',float)
#A = np.loadtxt('albert_barabasi_mean_degree14_network(200).txt',float)
G=nx.Graph(A)
degree = A.sum(axis=1)
row_sums= A.sum(axis=1)
A1=A/row_sums[:,np.newaxis]

#e_v_c=nx.eigenvector_centrality(G)
#c_c=nx.closeness_centrality(G)
bet_c=nx.betweenness_centrality(G)
clu_c=nx.clustering(G)
bet=[]
clu=[]
for i in range(0,N):
    bet.append(bet_c[i])
    clu.append(clu_c[i])
a=[]
for i in range(0,N):
    a.append(1./N)
a3=[x/np.sum(degree) for x in degree]
#a4=[x/np.sum(eigen) for x in eigen]
#a5=[x/np.sum(clo) for x in clo]
a6=[x/np.sum(bet) for x in bet]
a7=[x/np.sum(clu) for x in clu]

#B=np.loadtxt('uniformly_distributed_beta.txt',float)
B=np.loadtxt('distributed_beta_500.txt',float)
#B=[]
#for i in range(0,N):
#    B.append(0.05)
v=np.zeros([5,N],float)
v[1,:]=a[:]
v[2,:]=a3[:]
v[3,:]=a6[:]
v[4,:]=a7[:]


       
#f1 = lambda x:c0+c1*x
def f(y,t):
    dy = np.empty(5*N+1,float)
    s = y[0:5*N:5]
    e = y[1:5*N:5]
    i_s = y[2:5*N:5]
    h = y[3:5*N:5]
    r = y[4:5*N:5]
    k = y[2500]
    S1 = np.dot(A1,s)
    S2 = np.dot(A1,e)
    S3 = np.dot(A1,i_s)
    S4 = np.dot(A1,r)
    #alpha = f1(k)
    for i in range(0,N):
        dy[5*i] = ((-B[i]*s[i]*i_s[i])/H[i] )+K*(S1[i]-s[i])
        dy[5*i+1] = ((B[i]*s[i]*i_s[i])/H[i]) -sigma*e[i] + K*(S2[i]- e[i])
        dy[5*i+2] = sigma*e[i] - (c0+(c1*R[i]*k))*i_s[i] + K*(S3[i] - i_s[i])
        dy[5*i+3] = (c0+(c1*R[i]*k))*i_s[i] - gamma*h[i] -delta*h[i]
        dy[5*i+4] = gamma*h[i] + K*(S4[i] - r[i])
    dy[2500] = xi*(np.sum(i_s)) - ki*k
    return dy
i_peak=[] 
peak_av=[] 
std_av=[]  
for k in range(4,5):
    print(k)
    R=v[k]
    sigma=0.1
    delta=0.0
    gamma=0.07
    c0=0.01
    c1=0.0001
    tf = 2000
    xi = 0.02
    ki = 0.1
    K=0.05
    y0 = np.zeros(5*N+1,float)
    y0[0:5*N:5]=10000.
    y0[1:5*N+1:5]=0
    y0[2:5*N+2:5]=0
    y0[3:5*N+3:5]=0  
    y0[4:5*N+4:5]=0
    y0[0]=10000-20
    y0[1]=13
    y0[2]=7
    y0[3]=0.
    y0[4]=0.
    y0[2500]=10
    t1= np.linspace(0, tf, tf*100)
    [sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)


    i_1=[]
    for  i in range(0,N):
        i_1.append(np.max(sol1[:,5*i+2]))
  
    i_2=[]
    for i in range(0,tf*100):
        i_2.append(np.sum(sol1[i,2:5*N:5])/5000000.)
    i_peak.append(np.max(i_2))
    time = []
    for i in range(2,5*N,5):
        time.append(np.argmax(sol1[:,i]))
    time = [z/100. for z in time]
    time1=[x-time[0] for x in time]
    
data=np.linspace(min(degree),max(degree),10)
L3= len(data)
tf=[]
tf_av=[]
for j in range(1,L3):
    for i in range(0,N-1):
        if data[j-1] < degree[i] < data[j]:
            tf.append(i_1[i])
    tf_av.append(np.mean(tf))
    del tf[:]    
#em = [x  for x in eav if not np.isnan(eav)]
#em = [x for x in eav if str(x) != 'nan']   
d1=[]
for j in range(1,L3):
    d1.append((data[j-1]+data[j])/2)    
#    i_3=(np.dot(A1,sol1[:,2:5*N:5].transpose()))
#    i_4=K*(i_3[249,:]-sol1[:,1247])
#np.savetxt('er_network_cum_inf_without_kit_k0.001_uniform_1.txt',i_2)
#np.savetxt('er_network_inf_peak_without_kit_k0.001_uniform_1.txt',i_1)
#    l=['without-kit','identical','degree','betweenness','clustering','optimal']
#    markers=["kx","bo","gP","ms","yX",'r+']
#    l2=['k--','b--','g--','m--','y--','r--']
#    ind1=(0,50000,100000,150000,200000,250000,300000)
#    ind2=(0,0.05,.1,.15,.2)
#    pl.figure(1)
#    ma_on=[0,20000,40000,60000,80000,100000,120000,140000,160000,180000,200000,220000,240000,260000,280000]
#    pl.plot(sol1[:,47],l2[k])
#    pl.plot(ma_on,sol1[0:300000:20000,47],markers[k],label=l[k])
#    #pl.plot(i_2,label=l[k], )
#    pl.xlabel('$t$',fontsize=15)
#    pl.ylabel(r'$cum-inf$',fontsize=15)
#    pl.xticks(ind1,('0','500','1000','1500','2000','2500','3000'),fontsize=15)
#    #pl.yticks(ind2,('0','0.05','.1','.15','.2'),fontsize=15)
#    pl.rcParams['axes.linewidth']=2
#    pl.legend()
#    pl.tight_layout()

#    pl.figure(2)
#    ma_on=[0,20000,40000,60000,80000,100000,120000,140000,160000,180000,200000,220000,240000,260000,280000]
#    pl.plot(i_4,l2[k])
#    #pl.plot(degree,i_1,label=l[k])
#    pl.plot(ma_on,i_4[0:300000:20000],markers[k],label=l[k])
#    pl.xlabel('$t$',fontsize=15)
#    pl.ylabel(r'$coupling-term$',fontsize=15)
#    pl.xticks(ind1,('0','500','1000','1500','2000','2500','3000'),fontsize=15)
#    #pl.yticks(ind2,('0','.1','.2','.3'),fontsize=15)
#    pl.rcParams['axes.linewidth']=2
#    pl.legend()
#    pl.tight_layout()
#    del i_3
#    del i_4

    
#    m=peak_av
#   
#    #n=np.loadtxt('average_degree.txt',float)
#    l=np.arange(0.5,8.5,0.5)
#    P=l.reshape(4,4)
#    p=P.transpose()ol
#    p[0:4,1]=1+p[0:4,1]
#    p[0:4,2]=2+p[0:4,2]
#    p[0:4,3]=3+p[0:4,3]
#
#
#        
#    y=['identical','cluster','degree','betweenness']        
#    ind = (1.25,4.25,7.25,10.25) 
#    ind2=(0,0.25,0.5,0.75,1)           
#    pl.figure(4)
#
#    pl.hist(p[0,0],2,weights=m[0,0],color='b')
#    pl.hist(p[1,0],2,weights=m[3,0],color='y')
#    pl.hist(p[2,0],2,weights=m[1,0],color='g')
#    pl.hist(p[3,0],2,weights=m[2,0],color='m')
#    pl.hist(p[0,1],2,weights=m[0,1],color='b')
#    pl.hist(p[1,1],2,weights=m[3,1],color='y')
#    pl.hist(p[2,1],2,weights=m[1,1],color='g')
#    pl.hist(p[3,1],2,weights=m[2,1],color='m')
#    pl.hist(p[0,2],2,weights=m[0,2],color='b')
#    pl.hist(p[1,2],2,weights=m[3,2],color='y')
#    pl.hist(p[2,2],2,weights=m[1,2],color='g')
#    pl.hist(p[3,2],2,weights=m[2,2],color='m')
#    pl.hist(p[0,3],2,weights=m[0,3],color='b')
#    pl.hist(p[1,3],2,weights=m[3,3],color='y')
#    pl.hist(p[2,3],2,weights=m[1,3],color='g')
#    pl.hist(p[3,3],2,weights=m[2,3],color='m')
##x=np.arange(len(y))
##pl.barh(x,y)
#    pl.xlabel('$degree$',fontsize=15)
#    pl.ylabel(r'$<peak-inf>$',fontsize=15)
#    pl.xticks(ind,('0 - 20','20 - 35','35 - 47','47 - 61'),fontsize=15)
#    pl.yticks(ind2,('0','0.25','0.5','0.75','1'),fontsize=15)  
#    pl.tight_layout()
#    np.savetxt('peak_inf_average_300_o3_op.txt',peak_av)
#    np.savetxt('average_degree_500_op.txt',d0)
#    np.savetxt('degree_range_500_op.txt',data_2)
#    np.savetxt('std_500_op.txt',std_av)
#m1=1-(i_peak[1]/i_peak[0])
#m2=1-(i_peak[2]/i_peak[0])
#m3=1-(i_peak[3]/i_peak[0])
#m4=1-(i_peak[4]/i_peak[0])
#m5=1-(i_peak[5]/i_peak[0])
#m6=1-(i_peak[6]/i_peak[0])
#m7=1-(i_peak[7]/i_peak[0])
#m8=1-(i_peak[8]/i_peak[0])
#m=[m1,m2,m3,m4,m5,m6,m7,m8]
#y=[0,1,2,3,4,5,6,7]
#colors=pl.cm.rainbow(np.linspace(0,1,len(y)))
#pl.figure(2)
#pl.scatter(y,m,color=colors)    