# -*- coding: utf-8 -*-
"""
Created on Sun Jun 21 13:51:53 2020

@author: USER
"""

# -*- coding: utf-8 -*-
"""
Created on Wed Sep  4 19:01:28 2019

@author: Lenovo
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
#import scipy.io
import networkx as nx

N=500
H=np.zeros([N],float)
for i in range(0,N):
    H[i]=10000.
A=np.loadtxt('scale_free_network_500_14.txt',float) 
G=nx.Graph(A)
degree = A.sum(axis=1)
row_sums= A.sum(axis=1)
A1=A/row_sums[:,np.newaxis]
bet_c=nx.betweenness_centrality(G)
clu_c=nx.clustering(G)
bet=[]
clu=[]
for i in range(0,N):
    bet.append(bet_c[i])
    clu.append(clu_c[i])
    
a=[]
for i in range(0,N):
    a.append(1./N)

a3=[x/np.sum(degree) for x in degree]
a6=[x/np.sum(bet) for x in bet]
a7=[x/np.sum(clu) for x in clu]


#B=np.loadtxt('distributed_beta_500.txt',float)
B=[]
for i in range(0,N):
    B.append(0.05)
v=np.zeros([5,N],float)
v[1,:]=a[:]
v[2,:]=a3[:]
v[3,:]=a6[:]
v[4,:]=a7[:]
      
#f1 = lambda x:c0+c1*x
def f(y,t):
    dy = np.empty(5*N+1,float)
    s = y[0:5*N:5]
    e = y[1:5*N:5]
    i_s = y[2:5*N:5]
    h = y[3:5*N:5]
    r = y[4:5*N:5]
    k = y[2500]
    S1 = np.dot(A1,s)
    S2 = np.dot(A1,e)
    S3 = np.dot(A1,i_s)
    S4 = np.dot(A1,r)
    #alpha = f1(k)
    for i in range(0,N):
        dy[5*i] = ((-B[i]*s[i]*i_s[i])/H[i] )+K*(S1[i]-s[i])
        dy[5*i+1] = ((B[i]*s[i]*i_s[i])/H[i]) -sigma*e[i] + K*(S2[i]- e[i])
        dy[5*i+2] = sigma*e[i] - (c0+(c1*R[i]*k))*i_s[i] + K*(S3[i] - i_s[i])
        dy[5*i+3] = (c0+(c1*R[i]*k))*i_s[i] - gamma*h[i] -delta*h[i]
        dy[5*i+4] = gamma*h[i] + K*(S4[i]-r[i])
    dy[2500] = xi*(np.sum(i_s)) - ki*k
    return dy  

R=v[0]
sigma=0.1
delta=0.0
gamma=0.07
c0=0.01
c1=0.0001
tf = 3000
xi = 0.02
ki = 0.1
K=0.0005
for k in range(0,N):
    print(k)
    y0 = np.zeros(5*N+1,float)
    y0[0:5*N:5]=10000.
    file_1=open('kit_neigh_0.0005.txt','a')
    y0[5*k]=10000-20
    y0[5*k+1]=13
    y0[5*k+2]=7
    y0[2500]=10
    t1= np.linspace(0, tf, tf*100)
    [sol1,info] = odeint(f,y0,t1,full_output=1,printmessg=1)

    i_1=[]
    for  i in range(0,N):
        i_1.append(np.max(sol1[:,5*i+2]))
    i_peak=[]
    for i in range(0,N):
        i_peak.append(i_1[i]-i_1[k])   
             
    distance = []
    for i in range(0,N):
        distance.append(nx.shortest_path_length(G,k,i))
    time = []
    for i in range(2,5*N,5):
        time.append(np.argmax(sol1[:,i]))
    time = [z/100. for z in time]
    time1=[]
    for i in range(0,N):
        time1.append(time[i]-time[k])   
    for i in range(0,N):
        file_1.write("%s %s %s %s %s %s %s\n" % (str(i),str(degree[i]),str(distance[i]),str(i_1[i]),str(i_peak[i]),str(time[i]),str(time1[i])))
    file_1.close()