# -*- coding: utf-8 -*-
"""
Created on Sat Jun 20 14:51:27 2020

@author: USER
"""

import numpy as np
from numpy import *
from scipy import stats
from scipy.integrate import odeint
import pylab as pl
import random
import math
import networkx as nx

m=np.loadtxt('network_density_kit_0.03.txt',float)
n=np.loadtxt('network_density_zfos_0.03.txt',float)
ma_on=[4,6,8,10,12,14]
markers=["ko-","b*-","gs-","rp-","D-"]
marker=["--"]
k=[4,6,8,10,12,14]
pl.figure(1,figsize=(6,6))
pl.plot(k,m[:,0],'k--')
pl.plot(ma_on,m[:,0],markers[0],label='SW')
pl.plot(k,m[:,1],'b--')
pl.plot(ma_on,m[:,1],markers[1],label='SI')
pl.plot(k,m[:,2],'g--')
pl.plot(ma_on,m[:,2],markers[2],label='SD')
pl.plot(k,m[:,3],'r--')
pl.plot(ma_on,m[:,3],markers[3],label='SB')
pl.plot(k,m[:,4],'--',color='orange')
pl.plot(ma_on,m[:,4],markers[4],label='SC',color='#FFA500')
ind1=(4,8,12,16,17)
ind2=(0.1,0.2,0.3,0.4,0.5)
pl.xlabel(r'$\langle d \rangle$',fontsize=35)
pl.ylabel(r'$\mathcal{I}$',fontsize=35)
pl.xticks(ind1,('4','8','12','16',''),fontsize=30)
pl.yticks(ind2,('0.1','0.2','0.3','0.4','0.5'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
pl.legend(fontsize=16)
pl.tight_layout()

pl.figure(2,figsize=(6,6))
pl.plot(k,m[:,0],'k',linewidth=3)
pl.plot(ma_on,m[:,0],markers[0],label='SW',markersize=12,markeredgecolor='k')
pl.plot(k,m[:,1],'b',linewidth=3)
pl.plot(ma_on,m[:,1],markers[1],label='SI',markersize=16,markeredgecolor='b')
pl.plot(k,m[:,2],'g',linewidth=3)
pl.plot(ma_on,m[:,2],markers[2],label='SD',markersize=10,markeredgecolor='g')
pl.plot(k,m[:,3],'r',linewidth=3)
pl.plot(ma_on,m[:,3],markers[3],label='SB',markersize=14,markeredgecolor='r')
pl.plot(k,m[:,4],'-',color='orange',linewidth=3)
pl.plot(ma_on,m[:,4],markers[4],label='SC',color='#FFA500',markersize=10,markeredgecolor='orange')
ind1=(4,8,12,16)
ind2=(0,0.1,0.2,0.3)
pl.xlabel(r'$\langle d \rangle$',fontsize=35)
pl.ylabel(r'$\mathcal{I_{\rm max}}$',fontsize=35)
pl.xticks(ind1,('4','8','12','16'),fontsize=30)
pl.yticks(ind2,('0','0.1','0.2','0.3'),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
#pl.legend(bbox_to_anchor=(0.0,1.01),loc=7,ncol=5,borderaxespad=0, frameon=False,fontsize=16)
pl.tight_layout()

ind3=(0.6,0.8,1,1.2)
pl.figure(3,figsize=(6,6))
pl.plot(k,n[:,0],'k',linewidth=3)
pl.plot(ma_on,n[:,0],markers[0],label='SW',markersize=12,markeredgecolor='k')
pl.plot(k,n[:,1],'b',linewidth=3)
pl.plot(ma_on,n[:,1],markers[1],label='SI',markersize=16,markeredgecolor='b')
pl.plot(k,n[:,2],'g',linewidth=3)
pl.plot(ma_on,n[:,2],markers[2],label='SD',markersize=10,markeredgecolor='g')
pl.plot(k,n[:,3],'r',linewidth=3)
pl.plot(ma_on,n[:,3],markers[3],label='SB',markersize=14,markeredgecolor='r')
pl.plot(k,n[:,4],'-',color='orange',linewidth=3)
pl.plot(ma_on,n[:,4],markers[4],label='SC',color='#FFA500',markersize=10,markeredgecolor='orange')
pl.xlabel(r'$\langle d \rangle$',fontsize=35)
pl.ylabel(r'$\mathcal{Z_{\rm FOS}}$',fontsize=35)
pl.xticks(ind1,('4','8','12','16'),fontsize=30)
pl.yticks(ind3,('0.6','0.8','1',''),fontsize=30)
pl.rcParams['axes.linewidth']=2
pl.tick_params(direction= 'in', length=7,width=3)
#pl.legend(frameon=False,loc=7,fontsize=16)
pl.tight_layout()

